Index: Fl_lock.cxx
===================================================================
--- Fl_lock.cxx	(revision 5555)
+++ Fl_lock.cxx	(working copy)
@@ -172,6 +172,7 @@
 
 // Pipe for thread messaging...
 static int thread_filedes[2];
+static char thread_status = 0;
 
 // These pointers are in Fl_x.cxx:
 extern void (*fl_lock_function)();
@@ -185,7 +186,9 @@
 }
 
 static void thread_awake_cb(int fd, void*) {
-  read(fd, &thread_message_, sizeof(void*));
+  char tmp;
+  read(fd, &tmp, 1);
+  thread_status = 0;
 }
 
 void Fl::lock() {
@@ -200,7 +203,14 @@
 }
 
 void Fl::awake(void* msg) {
-  write(thread_filedes[1], &msg, sizeof(void*));
+  fl_lock_function();
+  thread_message_ = msg;
+  if(!thread_status)
+  {
+    thread_status = 1;
+    write(thread_filedes[1], &msg, 1);
+  }
+  fl_unlock_function();
 }
 
 #endif
